Index: /palm/trunk/SOURCE/salsa_mod.f90
===================================================================
--- /palm/trunk/SOURCE/salsa_mod.f90	(revision 3863)
+++ /palm/trunk/SOURCE/salsa_mod.f90	(revision 3864)
@@ -938,69 +1027,68 @@
 !------------------------------------------------------------------------------!
  SUBROUTINE salsa_init_arrays
- 
-    USE surface_mod,                                                           &
-        ONLY:  surf_def_h, surf_def_v, surf_lsm_h, surf_lsm_v, surf_usm_h,     &
-               surf_usm_v
+
+    USE chem_gasphase_mod,                                                                         &
+        ONLY:  nvar
+
+    USE surface_mod,                                                                               &
+        ONLY:  surf_def_h, surf_def_v, surf_lsm_h, surf_lsm_v, surf_usm_h, surf_usm_v
 
     IMPLICIT NONE
-    
-    INTEGER(iwp) ::  gases_available !< Number of available gas components in 
-                                     !< the chemistry model
-    INTEGER(iwp) ::  i   !< loop index for allocating
-    INTEGER(iwp) ::  l   !< loop index for allocating: surfaces
-    INTEGER(iwp) ::  lsp !< loop index for chem species in the chemistry model
-    
+
+    INTEGER(iwp) ::  gases_available !< Number of available gas components in the chemistry model
+    INTEGER(iwp) ::  i               !< loop index for allocating
+    INTEGER(iwp) ::  l               !< loop index for allocating: surfaces
+    INTEGER(iwp) ::  lsp             !< loop index for chem species in the chemistry model
+
     gases_available = 0
-
 !
 !-- Allocate prognostic variables (see salsa_swap_timelevel)
-
 !
 !-- Set derived indices:
-!-- (This does the same as the subroutine salsa_initialize in SALSA/
-!-- UCLALES-SALSA)        
-    in1a = 1                ! 1st index of subrange 1a
-    in2a = in1a + nbin(1)   ! 1st index of subrange 2a
-    fn1a = in2a - 1         ! last index of subrange 1a
-    fn2a = fn1a + nbin(2)   ! last index of subrange 2a
-    
-!    
-!-- If the fraction of insoluble aerosols in subrange 2 is zero: do not allocate
-!-- arrays for them
+!-- (This does the same as the subroutine salsa_initialize in SALSA/UCLALES-SALSA)
+    start_subrange_1a = 1  ! 1st index of subrange 1a
+    start_subrange_2a = start_subrange_1a + nbin(1)  ! 1st index of subrange 2a
+    end_subrange_1a   = start_subrange_2a - 1        ! last index of subrange 1a
+    end_subrange_2a   = end_subrange_1a + nbin(2)    ! last index of subrange 2a
+
+!
+!-- If the fraction of insoluble aerosols in subrange 2 is zero: do not allocate arrays for them
     IF ( nf2a > 0.999999_wp  .AND.  SUM( mass_fracs_b ) < 0.00001_wp )  THEN
        no_insoluble = .TRUE.
-       in2b = fn2a+1    ! 1st index of subrange 2b
-       fn2b = fn2a      ! last index of subrange 2b
+       start_subrange_2b = end_subrange_2a+1  ! 1st index of subrange 2b
+       end_subrange_2b   = end_subrange_2a    ! last index of subrange 2b
     ELSE
-       in2b = in2a + nbin(2)   ! 1st index of subrange 2b
-       fn2b = fn2a + nbin(2)   ! last index of subrange 2b
+       start_subrange_2b = start_subrange_2a + nbin(2)  ! 1st index of subrange 2b
+       end_subrange_2b   = end_subrange_2a + nbin(2)    ! last index of subrange 2b
     ENDIF
-    
-    
-    nbins = fn2b   ! total number of aerosol size bins
-!    
+
+    nbins_aerosol = end_subrange_2b   ! total number of aerosol size bins
+!
 !-- Create index tables for different aerosol components
     CALL component_index_constructor( prtcl, ncc, maxspec, listspec )
-    
-    ncc_tot = ncc
-    IF ( advect_particle_water )  ncc_tot = ncc + 1  ! Add water 
-    
+
+    ncomponents_mass = ncc
+    IF ( advect_particle_water )  ncomponents_mass = ncc + 1  ! Add water 
+
 !
 !-- Allocate:
-    ALLOCATE( aero(nbins), bin_low_limits(nbins), nsect(nbins), massacc(nbins) )
-    IF ( nldepo ) ALLOCATE( sedim_vd(nzb:nzt+1,nysg:nyng,nxlg:nxrg,nbins) )          
-    ALLOCATE( Ra_dry(nzb:nzt+1,nysg:nyng,nxlg:nxrg,nbins) )
-    
-!    
+    ALLOCATE( aero(nbins_aerosol), bc_am_t_val(nbins_aerosol*ncomponents_mass),                    &
+              bc_an_t_val(ngases_salsa), bc_gt_t_val(nbins_aerosol), bin_low_limits(nbins_aerosol),&
+              nsect(nbins_aerosol), massacc(nbins_aerosol) )
+    ALLOCATE( k_topo_top(nysg:nyng,nxlg:nxrg) )
+    IF ( nldepo ) ALLOCATE( sedim_vd(nzb:nzt+1,nysg:nyng,nxlg:nxrg,nbins_aerosol) )
+    ALLOCATE( ra_dry(nzb:nzt+1,nysg:nyng,nxlg:nxrg,nbins_aerosol) )
+
+!
 !-- Aerosol number concentration
-    ALLOCATE( aerosol_number(nbins) )
-    ALLOCATE( nconc_1(nzb:nzt+1,nysg:nyng,nxlg:nxrg,nbins),                    &
-              nconc_2(nzb:nzt+1,nysg:nyng,nxlg:nxrg,nbins),                    &
-              nconc_3(nzb:nzt+1,nysg:nyng,nxlg:nxrg,nbins) )
+    ALLOCATE( aerosol_number(nbins_aerosol) )
+    ALLOCATE( nconc_1(nzb:nzt+1,nysg:nyng,nxlg:nxrg,nbins_aerosol),                                &
+              nconc_2(nzb:nzt+1,nysg:nyng,nxlg:nxrg,nbins_aerosol),                                &
+              nconc_3(nzb:nzt+1,nysg:nyng,nxlg:nxrg,nbins_aerosol) )
     nconc_1 = 0.0_wp
     nconc_2 = 0.0_wp
     nconc_3 = 0.0_wp
-    
-    DO i = 1, nbins
+
+    DO i = 1, nbins_aerosol
        aerosol_number(i)%conc(nzb:nzt+1,nysg:nyng,nxlg:nxrg)    => nconc_1(:,:,:,i)
        aerosol_number(i)%conc_p(nzb:nzt+1,nysg:nyng,nxlg:nxrg)  => nconc_2(:,:,:,i)
@@ -1012,76 +1100,71 @@
                  aerosol_number(i)%init(nzb:nzt+1),                            &
                  aerosol_number(i)%sums_ws_l(nzb:nzt+1,0:threads_per_task-1) )
-    ENDDO      
-    
-!    
-!-- Aerosol mass concentration    
-    ALLOCATE( aerosol_mass(ncc_tot*nbins) ) 
-    ALLOCATE( mconc_1(nzb:nzt+1,nysg:nyng,nxlg:nxrg,ncc_tot*nbins),            &
-              mconc_2(nzb:nzt+1,nysg:nyng,nxlg:nxrg,ncc_tot*nbins),            &
-              mconc_3(nzb:nzt+1,nysg:nyng,nxlg:nxrg,ncc_tot*nbins) )
+    ENDDO
+
+!
+!-- Aerosol mass concentration
+    ALLOCATE( aerosol_mass(ncomponents_mass*nbins_aerosol) )
+    ALLOCATE( mconc_1(nzb:nzt+1,nysg:nyng,nxlg:nxrg,ncomponents_mass*nbins_aerosol),               &
+              mconc_2(nzb:nzt+1,nysg:nyng,nxlg:nxrg,ncomponents_mass*nbins_aerosol),               &
+              mconc_3(nzb:nzt+1,nysg:nyng,nxlg:nxrg,ncomponents_mass*nbins_aerosol) )
     mconc_1 = 0.0_wp
     mconc_2 = 0.0_wp
     mconc_3 = 0.0_wp
-    
-    DO i = 1, ncc_tot*nbins
+
+    DO i = 1, ncomponents_mass*nbins_aerosol
        aerosol_mass(i)%conc(nzb:nzt+1,nysg:nyng,nxlg:nxrg)    => mconc_1(:,:,:,i)
        aerosol_mass(i)%conc_p(nzb:nzt+1,nysg:nyng,nxlg:nxrg)  => mconc_2(:,:,:,i)
-       aerosol_mass(i)%tconc_m(nzb:nzt+1,nysg:nyng,nxlg:nxrg) => mconc_3(:,:,:,i)       
-       ALLOCATE( aerosol_mass(i)%flux_s(nzb+1:nzt,0:threads_per_task-1),       &
-                 aerosol_mass(i)%diss_s(nzb+1:nzt,0:threads_per_task-1),       &
-                 aerosol_mass(i)%flux_l(nzb+1:nzt,nys:nyn,0:threads_per_task-1),&
-                 aerosol_mass(i)%diss_l(nzb+1:nzt,nys:nyn,0:threads_per_task-1),&
-                 aerosol_mass(i)%init(nzb:nzt+1),                              &
+       aerosol_mass(i)%tconc_m(nzb:nzt+1,nysg:nyng,nxlg:nxrg) => mconc_3(:,:,:,i)
+       ALLOCATE( aerosol_mass(i)%flux_s(nzb+1:nzt,0:threads_per_task-1),                           &
+                 aerosol_mass(i)%diss_s(nzb+1:nzt,0:threads_per_task-1),                           &
+                 aerosol_mass(i)%flux_l(nzb+1:nzt,nys:nyn,0:threads_per_task-1),                   &
+                 aerosol_mass(i)%diss_l(nzb+1:nzt,nys:nyn,0:threads_per_task-1),                   &
+                 aerosol_mass(i)%init(nzb:nzt+1),                                                  &
                  aerosol_mass(i)%sums_ws_l(nzb:nzt+1,0:threads_per_task-1)  )
     ENDDO
-    
-!
-!-- Surface fluxes: answs = aerosol number, amsws = aerosol mass 
+
+!
+!-- Surface fluxes: answs = aerosol number, amsws = aerosol mass
 !
 !-- Horizontal surfaces: default type
     DO  l = 0, 2   ! upward (l=0), downward (l=1) and model top (l=2)
-       ALLOCATE( surf_def_h(l)%answs( 1:surf_def_h(l)%ns, nbins ) )
-       ALLOCATE( surf_def_h(l)%amsws( 1:surf_def_h(l)%ns, nbins*ncc_tot ) )
+       ALLOCATE( surf_def_h(l)%answs( 1:surf_def_h(l)%ns, nbins_aerosol ) )
+       ALLOCATE( surf_def_h(l)%amsws( 1:surf_def_h(l)%ns, nbins_aerosol*ncomponents_mass ) )
        surf_def_h(l)%answs = 0.0_wp
        surf_def_h(l)%amsws = 0.0_wp
     ENDDO
-!-- Horizontal surfaces: natural type    
-    IF ( land_surface )  THEN
-       ALLOCATE( surf_lsm_h%answs( 1:surf_lsm_h%ns, nbins ) )
-       ALLOCATE( surf_lsm_h%amsws( 1:surf_lsm_h%ns, nbins*ncc_tot ) )
-       surf_lsm_h%answs = 0.0_wp
-       surf_lsm_h%amsws = 0.0_wp
-    ENDIF
-!-- Horizontal surfaces: urban type 
-    IF ( urban_surface )  THEN
-       ALLOCATE( surf_usm_h%answs( 1:surf_usm_h%ns, nbins ) )
-       ALLOCATE( surf_usm_h%amsws( 1:surf_usm_h%ns, nbins*ncc_tot ) )
-       surf_usm_h%answs = 0.0_wp
-       surf_usm_h%amsws = 0.0_wp
-    ENDIF
-!
-!-- Vertical surfaces: northward (l=0), southward (l=1), eastward (l=2) and 
-!-- westward (l=3) facing
-    DO  l = 0, 3    
-       ALLOCATE( surf_def_v(l)%answs( 1:surf_def_v(l)%ns, nbins ) )
+!
+!-- Horizontal surfaces: natural type
+    ALLOCATE( surf_lsm_h%answs( 1:surf_lsm_h%ns, nbins_aerosol ) )
+    ALLOCATE( surf_lsm_h%amsws( 1:surf_lsm_h%ns, nbins_aerosol*ncomponents_mass ) )
+    surf_lsm_h%answs = 0.0_wp
+    surf_lsm_h%amsws = 0.0_wp
+!
+!-- Horizontal surfaces: urban type
+    ALLOCATE( surf_usm_h%answs( 1:surf_usm_h%ns, nbins_aerosol ) )
+    ALLOCATE( surf_usm_h%amsws( 1:surf_usm_h%ns, nbins_aerosol*ncomponents_mass ) )
+    surf_usm_h%answs = 0.0_wp
+    surf_usm_h%amsws = 0.0_wp
+
+!
+!-- Vertical surfaces: northward (l=0), southward (l=1), eastward (l=2) and westward (l=3) facing
+    DO  l = 0, 3
+       ALLOCATE( surf_def_v(l)%answs( 1:surf_def_v(l)%ns, nbins_aerosol ) )
        surf_def_v(l)%answs = 0.0_wp
-       ALLOCATE( surf_def_v(l)%amsws( 1:surf_def_v(l)%ns, nbins*ncc_tot ) )
+       ALLOCATE( surf_def_v(l)%amsws( 1:surf_def_v(l)%ns, nbins_aerosol*ncomponents_mass ) )
        surf_def_v(l)%amsws = 0.0_wp
-       
-       IF ( land_surface)  THEN
-          ALLOCATE( surf_lsm_v(l)%answs( 1:surf_lsm_v(l)%ns, nbins ) )
-          surf_lsm_v(l)%answs = 0.0_wp
-          ALLOCATE( surf_lsm_v(l)%amsws( 1:surf_lsm_v(l)%ns, nbins*ncc_tot ) )
-          surf_lsm_v(l)%amsws = 0.0_wp
-       ENDIF
-       
-       IF ( urban_surface )  THEN
-          ALLOCATE( surf_usm_v(l)%answs( 1:surf_usm_v(l)%ns, nbins ) )
-          surf_usm_v(l)%answs = 0.0_wp
-          ALLOCATE( surf_usm_v(l)%amsws( 1:surf_usm_v(l)%ns, nbins*ncc_tot ) )
-          surf_usm_v(l)%amsws = 0.0_wp
-       ENDIF
-    ENDDO    
-    
+
+       ALLOCATE( surf_lsm_v(l)%answs( 1:surf_lsm_v(l)%ns, nbins_aerosol ) )
+       surf_lsm_v(l)%answs = 0.0_wp
+       ALLOCATE( surf_lsm_v(l)%amsws( 1:surf_lsm_v(l)%ns, nbins_aerosol*ncomponents_mass ) )
+       surf_lsm_v(l)%amsws = 0.0_wp
+
+       ALLOCATE( surf_usm_v(l)%answs( 1:surf_usm_v(l)%ns, nbins_aerosol ) )
+       surf_usm_v(l)%answs = 0.0_wp
+       ALLOCATE( surf_usm_v(l)%amsws( 1:surf_usm_v(l)%ns, nbins_aerosol*ncomponents_mass ) )
+       surf_usm_v(l)%amsws = 0.0_wp
+
+    ENDDO
+
 !
 !-- Concentration of gaseous tracers (1. SO4, 2. HNO3, 3. NH3, 4. OCNV, 5. OCSV)
@@ -1091,45 +1174,44 @@
 !-- allocate salsa_gas array.
 
-    IF ( air_chemistry )  THEN   
+    IF ( air_chemistry )  THEN
        DO  lsp = 1, nvar
-          IF ( TRIM( chem_species(lsp)%name ) == 'H2SO4' )  THEN
-             gases_available = gases_available + 1
-             gas_index_chem(1) = lsp
-          ELSEIF ( TRIM( chem_species(lsp)%name ) == 'HNO3' )  THEN
-             gases_available = gases_available + 1  
-             gas_index_chem(2) = lsp
-          ELSEIF ( TRIM( chem_species(lsp)%name ) == 'NH3' )  THEN
-             gases_available = gases_available + 1
-             gas_index_chem(3) = lsp
-          ELSEIF ( TRIM( chem_species(lsp)%name ) == 'OCNV' )  THEN
-             gases_available = gases_available + 1
-             gas_index_chem(4) = lsp
-          ELSEIF ( TRIM( chem_species(lsp)%name ) == 'OCSV' )  THEN
-             gases_available = gases_available + 1
-             gas_index_chem(5) = lsp
-          ENDIF
+          SELECT CASE ( TRIM( chem_species(lsp)%name ) )
+             CASE ( 'H2SO4', 'h2so4' )
+                gases_available = gases_available + 1
+                gas_index_chem(1) = lsp
+             CASE ( 'HNO3', 'hno3' )
+                gases_available = gases_available + 1
+                gas_index_chem(2) = lsp
+             CASE ( 'NH3', 'nh3' )
+                gases_available = gases_available + 1
+                gas_index_chem(3) = lsp
+             CASE ( 'OCNV', 'ocnv' )
+                gases_available = gases_available + 1
+                gas_index_chem(4) = lsp
+             CASE ( 'OCSV', 'ocsv' )
+                gases_available = gases_available + 1
+                gas_index_chem(5) = lsp
+          END SELECT
        ENDDO
 
-       IF ( gases_available == ngast )  THEN
+       IF ( gases_available == ngases_salsa )  THEN
           salsa_gases_from_chem = .TRUE.
        ELSE
-          WRITE( message_string, * ) 'SALSA is run together with chemistry '// &
-                                     'but not all gaseous components are '//   &
-                                     'provided by kpp (H2SO4, HNO3, NH3, '//   &
-                                     'OCNV, OCSC)'
-       CALL message( 'check_parameters', 'SA0024', 1, 2, 0, 6, 0 )
+          WRITE( message_string, * ) 'SALSA is run together with chemistry but not all gaseous '// &
+                                     'components are provided by kpp (H2SO4, HNO3, NH3, OCNV, OCSV)'
+       CALL message( 'check_parameters', 'PA0599', 1, 2, 0, 6, 0 )
        ENDIF
 
     ELSE
 
-       ALLOCATE( salsa_gas(ngast) ) 
-       ALLOCATE( gconc_1(nzb:nzt+1,nysg:nyng,nxlg:nxrg,ngast),                 &
-                 gconc_2(nzb:nzt+1,nysg:nyng,nxlg:nxrg,ngast),                 &
-                 gconc_3(nzb:nzt+1,nysg:nyng,nxlg:nxrg,ngast) )
+       ALLOCATE( salsa_gas(ngases_salsa) )
+       ALLOCATE( gconc_1(nzb:nzt+1,nysg:nyng,nxlg:nxrg,ngases_salsa),                 &
+                 gconc_2(nzb:nzt+1,nysg:nyng,nxlg:nxrg,ngases_salsa),                 &
+                 gconc_3(nzb:nzt+1,nysg:nyng,nxlg:nxrg,ngases_salsa) )
        gconc_1 = 0.0_wp
        gconc_2 = 0.0_wp
        gconc_3 = 0.0_wp
-       
-       DO i = 1, ngast
+
+       DO i = 1, ngases_salsa
           salsa_gas(i)%conc(nzb:nzt+1,nysg:nyng,nxlg:nxrg)    => gconc_1(:,:,:,i)
           salsa_gas(i)%conc_p(nzb:nzt+1,nysg:nyng,nxlg:nxrg)  => gconc_2(:,:,:,i)
@@ -1141,5 +1223,5 @@
                     salsa_gas(i)%init(nzb:nzt+1),                              &
                     salsa_gas(i)%sums_ws_l(nzb:nzt+1,0:threads_per_task-1) )
-       ENDDO       
+       ENDDO
 !
 !--    Surface fluxes: gtsws = gaseous tracer flux
@@ -1147,34 +1229,26 @@
 !--    Horizontal surfaces: default type
        DO  l = 0, 2   ! upward (l=0), downward (l=1) and model top (l=2)
-          ALLOCATE( surf_def_h(l)%gtsws( 1:surf_def_h(l)%ns, ngast ) )
+          ALLOCATE( surf_def_h(l)%gtsws( 1:surf_def_h(l)%ns, ngases_salsa ) )
           surf_def_h(l)%gtsws = 0.0_wp
        ENDDO
-!--    Horizontal surfaces: natural type   
-       IF ( land_surface )  THEN
-          ALLOCATE( surf_lsm_h%gtsws( 1:surf_lsm_h%ns, ngast ) )
-          surf_lsm_h%gtsws = 0.0_wp
-       ENDIF
-!--    Horizontal surfaces: urban type          
-       IF ( urban_surface )  THEN 
-          ALLOCATE( surf_usm_h%gtsws( 1:surf_usm_h%ns, ngast ) )
-          surf_usm_h%gtsws = 0.0_wp
-       ENDIF
+!--    Horizontal surfaces: natural type
+       ALLOCATE( surf_lsm_h%gtsws( 1:surf_lsm_h%ns, ngases_salsa ) )
+       surf_lsm_h%gtsws = 0.0_wp
+!--    Horizontal surfaces: urban type
+       ALLOCATE( surf_usm_h%gtsws( 1:surf_usm_h%ns, ngases_salsa ) )
+       surf_usm_h%gtsws = 0.0_wp
 !
 !--    Vertical surfaces: northward (l=0), southward (l=1), eastward (l=2) and 
 !--    westward (l=3) facing
-       DO  l = 0, 3     
-          ALLOCATE( surf_def_v(l)%gtsws( 1:surf_def_v(l)%ns, ngast ) )
+       DO  l = 0, 3
+          ALLOCATE( surf_def_v(l)%gtsws( 1:surf_def_v(l)%ns, ngases_salsa ) )
           surf_def_v(l)%gtsws = 0.0_wp
-          IF ( land_surface )  THEN
-             ALLOCATE( surf_lsm_v(l)%gtsws( 1:surf_lsm_v(l)%ns, ngast ) )
-             surf_lsm_v(l)%gtsws = 0.0_wp
-          ENDIF
-          IF ( urban_surface )  THEN
-             ALLOCATE( surf_usm_v(l)%gtsws( 1:surf_usm_v(l)%ns, ngast ) )
-             surf_usm_v(l)%gtsws = 0.0_wp
-          ENDIF
+          ALLOCATE( surf_lsm_v(l)%gtsws( 1:surf_lsm_v(l)%ns, ngases_salsa ) )
+          surf_lsm_v(l)%gtsws = 0.0_wp
+          ALLOCATE( surf_usm_v(l)%gtsws( 1:surf_usm_v(l)%ns, ngases_salsa ) )
+          surf_usm_v(l)%gtsws = 0.0_wp
        ENDDO
     ENDIF
-    
+
  END SUBROUTINE salsa_init_arrays
 
@@ -1182,5 +1256,5 @@
 ! Description:
 ! ------------
-!> Initialization of SALSA. Based on salsa_initialize in UCLALES-SALSA. 
+!> Initialization of SALSA. Based on salsa_initialize in UCLALES-SALSA.
 !> Subroutines salsa_initialize, SALSAinit and DiagInitAero in UCLALES-SALSA are
 !> also merged here.
@@ -1189,56 +1263,59 @@
 
     IMPLICIT NONE
-    
-    INTEGER(iwp) :: b
-    INTEGER(iwp) :: c
-    INTEGER(iwp) :: g
-    INTEGER(iwp) :: i
-    INTEGER(iwp) :: j
-    
-    CALL location_message( 'initializing SALSA model', .TRUE. )
-    
+
+    INTEGER(iwp) :: i   !<
+    INTEGER(iwp) :: ib  !< loop index for aerosol number bins
+    INTEGER(iwp) :: ic  !< loop index for aerosol mass bins
+    INTEGER(iwp) :: ig  !< loop index for gases
+    INTEGER(iwp) :: ii  !< index for indexing
+    INTEGER(iwp) :: j   !<
+
+    CALL location_message( 'initializing salsa (sectional aerosol module )', .TRUE. )
+
     bin_low_limits = 0.0_wp
+    k_topo_top     = 0
     nsect          = 0.0_wp
-    massacc        = 1.0_wp 
-    
+    massacc        = 1.0_wp
+
 !
 !-- Indices for chemical components used (-1 = not used)
-    i = 0
+    ii = 0
     IF ( is_used( prtcl, 'SO4' ) )  THEN
-       iso4 = get_index( prtcl,'SO4' )
-       i = i + 1
+       index_so4 = get_index( prtcl,'SO4' )
+       ii = ii + 1
     ENDIF
     IF ( is_used( prtcl,'OC' ) )  THEN
-       ioc = get_index(prtcl, 'OC')
-       i = i + 1
+       index_oc = get_index(prtcl, 'OC')
+       ii = ii + 1
     ENDIF
     IF ( is_used( prtcl, 'BC' ) )  THEN
-       ibc = get_index( prtcl, 'BC' )
-       i = i + 1
+       index_bc = get_index( prtcl, 'BC' )
+       ii = ii + 1
     ENDIF
     IF ( is_used( prtcl, 'DU' ) )  THEN
-       idu = get_index( prtcl, 'DU' )
-       i = i + 1
+       index_du = get_index( prtcl, 'DU' )
+       ii = ii + 1
     ENDIF
     IF ( is_used( prtcl, 'SS' ) )  THEN
-       iss = get_index( prtcl, 'SS' )
-       i = i + 1
+       index_ss = get_index( prtcl, 'SS' )
+       ii = ii + 1
     ENDIF
     IF ( is_used( prtcl, 'NO' ) )  THEN
-       ino = get_index( prtcl, 'NO' )
-       i = i + 1
+       index_no = get_index( prtcl, 'NO' )
+       ii = ii + 1
     ENDIF
     IF ( is_used( prtcl, 'NH' ) )  THEN
-       inh = get_index( prtcl, 'NH' )
-       i = i + 1
+       index_nh = get_index( prtcl, 'NH' )
+       ii = ii + 1
     ENDIF
-!    
+!
 !-- All species must be known
-    IF ( i /= ncc )  THEN
-       message_string = 'Unknown aerosol species/component(s) given in the' // &
-                        ' initialization'
-       CALL message( 'salsa_mod: salsa_init', 'SA0020', 1, 2, 0, 6, 0 )
+    IF ( ii /= ncc )  THEN
+       message_string = 'Unknown aerosol species/component(s) given in the initialization'
+       CALL message( 'salsa_mod: salsa_init', 'PA0600', 1, 2, 0, 6, 0 )
     ENDIF
-    
+!
+!-- Partition and dissolutional growth by gaseous HNO3 and NH3
+    IF ( index_no > 0  .AND.  index_nh > 0  .AND.  index_so4 > 0 )  lspartition = .TRUE.
 !
 !-- Initialise
@@ -1249,63 +1326,63 @@
     aero(:)%numc     = nclim
     aero(:)%core     = 1.0E-10_wp
-    DO c = 1, maxspec+1    ! 1:SO4, 2:OC, 3:BC, 4:DU, 5:SS, 6:NO, 7:NH, 8:H2O
-       aero(:)%volc(c) = 0.0_wp
+    DO ic = 1, maxspec+1    ! 1:SO4, 2:OC, 3:BC, 4:DU, 5:SS, 6:NO, 7:NH, 8:H2O
+       aero(:)%volc(ic) = 0.0_wp
     ENDDO
-    
-    IF ( nldepo )  sedim_vd = 0.0_wp  
-    
-    DO  b = 1, nbins
-       IF ( .NOT. read_restart_data_salsa )  aerosol_number(b)%conc = nclim
-       aerosol_number(b)%conc_p    = 0.0_wp
-       aerosol_number(b)%tconc_m   = 0.0_wp
-       aerosol_number(b)%flux_s    = 0.0_wp
-       aerosol_number(b)%diss_s    = 0.0_wp
-       aerosol_number(b)%flux_l    = 0.0_wp
-       aerosol_number(b)%diss_l    = 0.0_wp
-       aerosol_number(b)%init      = nclim
-       aerosol_number(b)%sums_ws_l = 0.0_wp
+
+    IF ( nldepo )  sedim_vd = 0.0_wp
+
+    DO  ib = 1, nbins_aerosol
+       IF ( .NOT. read_restart_data_salsa )  aerosol_number(ib)%conc = nclim
+       aerosol_number(ib)%conc_p    = 0.0_wp
+       aerosol_number(ib)%tconc_m   = 0.0_wp
+       aerosol_number(ib)%flux_s    = 0.0_wp
+       aerosol_number(ib)%diss_s    = 0.0_wp
+       aerosol_number(ib)%flux_l    = 0.0_wp
+       aerosol_number(ib)%diss_l    = 0.0_wp
+       aerosol_number(ib)%init      = nclim
+       aerosol_number(ib)%sums_ws_l = 0.0_wp
     ENDDO
-    DO  c = 1, ncc_tot*nbins
-       IF ( .NOT. read_restart_data_salsa )  aerosol_mass(c)%conc = mclim
-       aerosol_mass(c)%conc_p    = 0.0_wp
-       aerosol_mass(c)%tconc_m   = 0.0_wp
-       aerosol_mass(c)%flux_s    = 0.0_wp
-       aerosol_mass(c)%diss_s    = 0.0_wp
-       aerosol_mass(c)%flux_l    = 0.0_wp
-       aerosol_mass(c)%diss_l    = 0.0_wp
-       aerosol_mass(c)%init      = mclim
-       aerosol_mass(c)%sums_ws_l = 0.0_wp
+    DO  ic = 1, ncomponents_mass*nbins_aerosol
+       IF ( .NOT. read_restart_data_salsa )  aerosol_mass(ic)%conc = mclim
+       aerosol_mass(ic)%conc_p    = 0.0_wp
+       aerosol_mass(ic)%tconc_m   = 0.0_wp
+       aerosol_mass(ic)%flux_s    = 0.0_wp
+       aerosol_mass(ic)%diss_s    = 0.0_wp
+       aerosol_mass(ic)%flux_l    = 0.0_wp
+       aerosol_mass(ic)%diss_l    = 0.0_wp
+       aerosol_mass(ic)%init      = mclim
+       aerosol_mass(ic)%sums_ws_l = 0.0_wp
     ENDDO
-    
+
     IF ( .NOT. salsa_gases_from_chem )  THEN
-       DO  g = 1, ngast
-          salsa_gas(g)%conc_p    = 0.0_wp
-          salsa_gas(g)%tconc_m   = 0.0_wp
-          salsa_gas(g)%flux_s    = 0.0_wp
-          salsa_gas(g)%diss_s    = 0.0_wp
-          salsa_gas(g)%flux_l    = 0.0_wp
-          salsa_gas(g)%diss_l    = 0.0_wp
-          salsa_gas(g)%sums_ws_l = 0.0_wp
+       DO  ig = 1, ngases_salsa
+          salsa_gas(ig)%conc_p    = 0.0_wp
+          salsa_gas(ig)%tconc_m   = 0.0_wp
+          salsa_gas(ig)%flux_s    = 0.0_wp
+          salsa_gas(ig)%diss_s    = 0.0_wp
+          salsa_gas(ig)%flux_l    = 0.0_wp
+          salsa_gas(ig)%diss_l    = 0.0_wp
+          salsa_gas(ig)%sums_ws_l = 0.0_wp
        ENDDO
        IF ( .NOT. read_restart_data_salsa )  THEN
-          salsa_gas(1)%conc = H2SO4_init
-          salsa_gas(2)%conc = HNO3_init
-          salsa_gas(3)%conc = NH3_init
-          salsa_gas(4)%conc = OCNV_init
-          salsa_gas(5)%conc = OCSV_init 
+          salsa_gas(1)%conc = h2so4_init
+          salsa_gas(2)%conc = hno3_init
+          salsa_gas(3)%conc = nh3_init
+          salsa_gas(4)%conc = ocnv_init
+          salsa_gas(5)%conc = ocsv_init 
        ENDIF
 !
 !--    Set initial value for gas compound tracers and initial values
-       salsa_gas(1)%init = H2SO4_init
-       salsa_gas(2)%init = HNO3_init
-       salsa_gas(3)%init = NH3_init
-       salsa_gas(4)%init = OCNV_init
-       salsa_gas(5)%init = OCSV_init      
+       salsa_gas(1)%init = h2so4_init
+       salsa_gas(2)%init = hno3_init
+       salsa_gas(3)%init = nh3_init
+       salsa_gas(4)%init = ocnv_init
+       salsa_gas(5)%init = ocsv_init
     ENDIF
 !
 !-- Aerosol radius in each bin: dry and wet (m)
-    Ra_dry = 1.0E-10_wp
-!    
-!-- Initialise aerosol tracers    
+    ra_dry = 1.0E-10_wp
+!
+!-- Initialise aerosol tracers
     aero(:)%vhilim   = 0.0_wp
     aero(:)%vlolim   = 0.0_wp
@@ -1315,25 +1392,34 @@
 !
 !-- Initialise the sectional particle size distribution
-    CALL set_sizebins()
-!
-!-- Initialise location-dependent aerosol size distributions and 
-!-- chemical compositions:
-    CALL aerosol_init 
-!
-!-- Initalisation run of SALSA
+    CALL set_sizebins
+!
+!-- Initialise location-dependent aerosol size distributions and chemical compositions:
+    CALL aerosol_init
+!
+!-- Initalisation run of SALSA + calculate the vertical top index of the topography
     DO  i = nxl, nxr
        DO  j = nys, nyn
+
+          k_topo_top(j,i) = MAXLOC( MERGE( 1, 0, BTEST( wall_flags_0(:,j,i), 12 ) ), DIM = 1 ) - 1
+
           CALL salsa_driver( i, j, 1 )
           CALL salsa_diagnostics( i, j )
        ENDDO
-    ENDDO 
-!
-!-- Set the aerosol and gas sources
-    IF ( salsa_source_mode == 'read_from_file' )  THEN
-       CALL salsa_set_source
+    ENDDO
+!
+!-- Initialise the deposition scheme and surface types
+    IF ( nldepo )  CALL init_deposition
+
+    IF ( salsa_emission_mode /= 'no_emission' )  THEN
+!
+!--    Read in and initialize emissions
+       CALL salsa_emission_setup( .TRUE. )
+       IF ( .NOT. salsa_gases_from_chem  .AND.  salsa_emission_mode == 'read_from_file' )  THEN
+          CALL salsa_gas_emission_setup( .TRUE. )
+       ENDIF
     ENDIF
-    
+
     CALL location_message( 'finished', .TRUE. )
-    
+
  END SUBROUTINE salsa_init
 
@@ -1363,13 +1449,13 @@
 !------------------------------------------------------------------------------!
  SUBROUTINE set_sizebins
-               
+
     IMPLICIT NONE
-!    
-!-- Local variables
-    INTEGER(iwp) ::  cc
-    INTEGER(iwp) ::  dd
-    REAL(wp) ::  ratio_d !< ratio of the upper and lower diameter of subranges
-!
-!-- vlolim&vhilim: min & max *dry* volumes [fxm] 
+
+    INTEGER(iwp) ::  cc  !< running index
+    INTEGER(iwp) ::  dd  !< running index
+
+    REAL(wp) ::  ratio_d  !< ratio of the upper and lower diameter of subranges
+!
+!-- vlolim&vhilim: min & max *dry* volumes [fxm]
 !-- dmid: bin mid *dry* diameter (m)
 !-- vratiolo&vratiohi: volume ratio between the center and low/high limit
@@ -1377,50 +1463,45 @@
 !-- 1) Size subrange 1:
     ratio_d = reglim(2) / reglim(1)   ! section spacing (m)
-    DO  cc = in1a,fn1a
-       aero(cc)%vlolim = api6 * ( reglim(1) * ratio_d **                       &
-                                ( REAL( cc-1 ) / nbin(1) ) ) ** 3.0_wp
-       aero(cc)%vhilim = api6 * ( reglim(1) * ratio_d **                       &
-                                ( REAL( cc ) / nbin(1) ) ) ** 3.0_wp
-       aero(cc)%dmid = SQRT( ( aero(cc)%vhilim / api6 ) ** ( 1.0_wp / 3.0_wp ) &
-                           * ( aero(cc)%vlolim / api6 ) ** ( 1.0_wp / 3.0_wp ) )
-       aero(cc)%vratiohi = aero(cc)%vhilim / ( api6 * aero(cc)%dmid ** 3.0_wp )
-       aero(cc)%vratiolo = aero(cc)%vlolim / ( api6 * aero(cc)%dmid ** 3.0_wp )
+    DO  cc = start_subrange_1a, end_subrange_1a
+       aero(cc)%vlolim = api6 * ( reglim(1) * ratio_d**( REAL( cc-1 ) / nbin(1) ) )**3
+       aero(cc)%vhilim = api6 * ( reglim(1) * ratio_d**( REAL( cc ) / nbin(1) ) )**3
+       aero(cc)%dmid = SQRT( ( aero(cc)%vhilim / api6 )**0.33333333_wp *                           &
+                             ( aero(cc)%vlolim / api6 )**0.33333333_wp )
+       aero(cc)%vratiohi = aero(cc)%vhilim / ( api6 * aero(cc)%dmid**3 )
+       aero(cc)%vratiolo = aero(cc)%vlolim / ( api6 * aero(cc)%dmid**3 )
     ENDDO
 !
-!-- 2) Size subrange 2: 
+!-- 2) Size subrange 2:
 !-- 2.1) Sub-subrange 2a: high hygroscopicity
     ratio_d = reglim(3) / reglim(2)   ! section spacing
-    DO  dd = in2a, fn2a
-       cc = dd - in2a
-       aero(dd)%vlolim = api6 * ( reglim(2) * ratio_d **                       &
-                                  ( REAL( cc ) / nbin(2) ) ) ** 3.0_wp
-       aero(dd)%vhilim = api6 * ( reglim(2) * ratio_d **                       &
-                                  ( REAL( cc+1 ) / nbin(2) ) ) ** 3.0_wp
-       aero(dd)%dmid = SQRT( ( aero(dd)%vhilim / api6 ) ** ( 1.0_wp / 3.0_wp ) &
-                           * ( aero(dd)%vlolim / api6 ) ** ( 1.0_wp / 3.0_wp ) )
-       aero(dd)%vratiohi = aero(dd)%vhilim / ( api6 * aero(dd)%dmid ** 3.0_wp )
-       aero(dd)%vratiolo = aero(dd)%vlolim / ( api6 * aero(dd)%dmid ** 3.0_wp )
+    DO  dd = start_subrange_2a, end_subrange_2a
+       cc = dd - start_subrange_2a
+       aero(dd)%vlolim = api6 * ( reglim(2) * ratio_d**( REAL( cc ) / nbin(2) ) )**3
+       aero(dd)%vhilim = api6 * ( reglim(2) * ratio_d**( REAL( cc+1 ) / nbin(2) ) )**3
+       aero(dd)%dmid = SQRT( ( aero(dd)%vhilim / api6 )**0.33333333_wp *                           &
+                             ( aero(dd)%vlolim / api6 )**0.33333333_wp )
+       aero(dd)%vratiohi = aero(dd)%vhilim / ( api6 * aero(dd)%dmid**3 )
+       aero(dd)%vratiolo = aero(dd)%vlolim / ( api6 * aero(dd)%dmid**3 )
     ENDDO
-!          
+!
 !-- 2.2) Sub-subrange 2b: low hygroscopicity
     IF ( .NOT. no_insoluble )  THEN
-       aero(in2b:fn2b)%vlolim   = aero(in2a:fn2a)%vlolim
-       aero(in2b:fn2b)%vhilim   = aero(in2a:fn2a)%vhilim
-       aero(in2b:fn2b)%dmid     = aero(in2a:fn2a)%dmid
-       aero(in2b:fn2b)%vratiohi = aero(in2a:fn2a)%vratiohi
-       aero(in2b:fn2b)%vratiolo = aero(in2a:fn2a)%vratiolo
+       aero(start_subrange_2b:end_subrange_2b)%vlolim   = aero(start_subrange_2a:end_subrange_2a)%vlolim
+       aero(start_subrange_2b:end_subrange_2b)%vhilim   = aero(start_subrange_2a:end_subrange_2a)%vhilim
+       aero(start_subrange_2b:end_subrange_2b)%dmid     = aero(start_subrange_2a:end_subrange_2a)%dmid
+       aero(start_subrange_2b:end_subrange_2b)%vratiohi = aero(start_subrange_2a:end_subrange_2a)%vratiohi
+       aero(start_subrange_2b:end_subrange_2b)%vratiolo = aero(start_subrange_2a:end_subrange_2a)%vratiolo
     ENDIF
-!          
-!-- Initialize the wet diameter with the bin dry diameter to avoid numerical 
-!-- problems later
+!
+!-- Initialize the wet diameter with the bin dry diameter to avoid numerical problems later
     aero(:)%dwet = aero(:)%dmid
 !
-!-- Save bin limits (lower diameter) to be delivered to the host model if needed
-    DO cc = 1, nbins
-       bin_low_limits(cc) = ( aero(cc)%vlolim / api6 )**( 1.0_wp / 3.0_wp )
-    ENDDO    
-    
+!-- Save bin limits (lower diameter) to be delivered to PALM if needed
+    DO cc = 1, nbins_aerosol
+       bin_low_limits(cc) = ( aero(cc)%vlolim / api6 )**0.33333333_wp
+    ENDDO
+
  END SUBROUTINE set_sizebins
- 
+
 !------------------------------------------------------------------------------!
 ! Description:
